* Function Original de brunellopulix (brunellopulix@yahoo.it)

# include "hbclass.ch"
# include 'common.ch'
# define  CRLF  chr(13)+chr(10)
#translate NTRIM( <v1> ) => ( Ltrim(str(<v1>)) )
*
*************************STATIC oRtf	
*
FUNCTION RtfStyle(cLabel,cOpz,cFont,cSize,cColor)
   LOCAL p1 := ""
   LOCAL p2 := ""
   LOCAL p3 := ""
   *
   DEFAULT cOpz   TO ""
   DEFAULT cFont  TO "0"
   DEFAULT cSize  TO "20"
   *DEFAULT cColor TO "0"
   if cColor == NIL
      cColor := "0"
   Endif
   *
   cOpz    :=  Upper(cOpz)
   p1      :=  '{'
   p1      +=  '\f'+cFont
   p2      +=  '\f0'
   p3      :=  "c"
   *
   p1      +=      '\cf'+cColor
   IF 'B'   $ cOpz // bold
      p1      +=      '\b'
      p2      +=      '\b0'
   ENDIF
   IF 'U' $ cOpz // Undeline
      p1      +=      '\ul'
      p2      +=      '\ulnone'
   ENDIF
   IF 'I'  $ cOpz  // Italic
      p1      +=      '\i'
      p2      +=      '\i0'
   ENDIF
   IF 'X'  $ cOpz  // Superscript
      p1      +=      '\super'
      p2      +=      '\nosupersub'
   ENDIF
   IF 'Y'  $ cOpz  // SubScript
      p1      +=      '\sub'
      p2      +=      '\nosupersub'
   ENDIF
   *
   p1      +=      '\fs'+cSize
   p2      +=      '\fs20'
   *
   IF Left(cLabel,1) $ '1234567890'
      p1 += ' '
   ENDIF
   p2 +=  '}'
   *
RETURN p1+cLabel+p2
*
CLASS XRtf
DATA Handle
DATA aTable_P
DATA aTable_L
DATA cOrientation
DATA aCoord_P
DATA aCoord_L
DATA aTable
DATA aCoord
DATA Page
DATA HRow
DATA ItemsCount
DATA CurRow
METHOD New(cFile,aTable,cOrient,cFont,cSize,aCoord)
METHOD SetOrientation(cOrient)
METHOD Close()
METHOD NewSection()
METHOD WriteFree(obj)
METHOD WriteRow(nTable,aRay)
METHOD WriteBmp(xFile)
METHOD PageHeader(x)
METHOD PageFooter(x)
METHOD NewPage()
METHOD EmptyRow()
METHOD BookMark(cBook,cText)
METHOD HiddenText(x)
ENDCLASS

METHOD New(cFile,aTable,cOrient,cFont,cSize,aCoord) CLASS XRtf
LOCAL i
LOCAL c1
*
Default(@cOrient,'P')
Default(@cFont,'0'  )
Default(@cSize,'20' )
Default(@aCoord,nil )
*
SELF:aCoord_P           := Array(6)
SELF:aCoord_L           := Array(6)
SELF:cOrientation       := cOrient
*
IF Upper(cOrient) == 'P'        && PORTRAIT
   *
   Default aCoord TO {210,297,15,15,15,15}
   *
   SELF:aCoord_P[1] := NTrim(Round(aCoord[1]*56.7,0))
   SELF:aCoord_P[2] := NTrim(Round(aCoord[2]*56.7,0))
   SELF:aCoord_L[1] := NTrim(Round(aCoord[2]*56.7,0))
   SELF:aCoord_L[2] := NTrim(Round(aCoord[1]*56.7,0))
   *
ELSE
   *
   Default aCoord To {297,210,15,15,15,15}
   *
   SELF:aCoord_L[1] := NTrim(Round(aCoord[1]*56.7,0))
   SELF:aCoord_L[2] := NTrim(Round(aCoord[2]*56.7,0))
   SELF:aCoord_P[1] := NTrim(Round(aCoord[2]*56.7,0))
   SELF:aCoord_P[2] := NTrim(Round(aCoord[1]*56.7,0))
   *
ENDIF
*
FOR i := 3 TO 6
   SELF:aCoord_P[i] := NTrim(Round(aCoord[i]*56.7,0))
   SELF:aCoord_L[i] := NTrim(Round(aCoord[i]*56.7,0))
NEXT
*
SELF:aTable_P := {}
SELF:aTable_L := {}
FOR i := 1 TO Len(aTable)
   AAdd(SELF:aTable_P,MakeList(MakeTable(aTable[i],SELF:aCoord_P)))
   AAdd(SELF:aTable_L,MakeList(MakeTable(aTable[i],SELF:aCoord_L)))
NEXT
*
SELF:Handle := FCreate(cFile,0)
FWrite(SELF:Handle,"{\rtf1\ansi{\fonttbl")
FWrite(SELF:Handle,"{\f0\fswiss Arial;}")
FWrite(SELF:Handle,"{\f1\fswiss Helv;}")
FWrite(SELF:Handle,"{\f2\froman Times New Roman;}")
FWrite(SELF:Handle,"{\f3\froman Courier;}")
FWrite(SELF:Handle,"{\f4\froman Roman;}")
FWrite(SELF:Handle,"{\f5\fmodern Modern;}")
FWrite(SELF:Handle,"{\f6\froman MS LineDraw;}")
FWrite(SELF:Handle,"{\f7\froman AdvOCR-B;}")
FWrite(SELF:Handle,"{\f8\froman Lucida Console;}")
FWrite(SELF:Handle,"{\f9\froman Courier New;}}"+CRLF)
*
FWrite(SELF:Handle,"{\colortbl\red0\green0\blue0;\red128")
FWrite(SELF:Handle,"\green0\blue0;\red0\green128\blue0;\red128")
FWrite(SELF:Handle,"\green128\blue0;\red0\green0\blue128;\red128")
FWrite(SELF:Handle,"\green0\blue128;\red0\green128\blue128;\red128")
FWrite(SELF:Handle,"\green128\blue128;\red192\green192\blue192;\red255")
FWrite(SELF:Handle,"\green0\blue0;\red0\green255\blue0;\red255\green255")
FWrite(SELF:Handle,"\blue0;\red0\green0\blue255;\red255\green0\blue255;\red0\green255\blue255;}"+CRLF)
*
c1 := "{\info{\author "+GetEnv('USERNAME')+"}"
c1 += "{\creatim "
c1 += "\yr"+NTrim(Year(date()))
c1 += "\mo"+NTrim(Month(date()))
c1 += "\dy"+NTrim(Day(date()))
c1 += "\hr"+Left(Time(),2)
c1 += "\min"+SubStr(Time(),4,2)
c1 += "}}"
*
FWrite(SELF:Handle,c1+CRLF)
*
FWrite(SELF:Handle,"\f"+cFont+"\fs"+cSize+CRLF)
SELF:SetOrientation(cOrient)
SELF:HRow       := "263" //"259"
SELF:ItemsCount := if(cOrient=='P',55,38)
SELF:Page   := 1
SELF:CurRow:= 0
*
RETURN SELF
METHOD SetOrientation(cOrient) CLASS XRtf
*
SELF:cOrientation := Upper(cOrient)
*
SELF:aTable := {}
IF cOrient == 'P'
   FWrite(SELF:Handle,;
   "\paperw" +SELF:aCoord_P[1]+;
   " \paperh"+SELF:aCoord_P[2]+;
   " \margl" +SELF:aCoord_P[3]+;
   " \margr" +SELF:aCoord_P[4]+;
   " \margt" +SELF:aCoord_P[5]+;
   " \margb" +SELF:aCoord_P[6]+''+CRLF)
   SELF:aTable := SELF:aTable_P
ELSE
   FWrite(SELF:Handle,;
   "\paperw" +SELF:aCoord_L[1]+;
   " \paperh"+SELF:aCoord_L[2]+;
   " \margl" +SELF:aCoord_L[3]+;
   " \margr" +SELF:aCoord_L[4]+;
   " \margt" +SELF:aCoord_L[5]+;
   " \margb" +SELF:aCoord_L[6]+'\landscape'+CRLF)
   SELF:aTable := SELF:aTable_L
ENDIF
FWrite(SELF:Handle,"\sectd \linex0 \sa10"+CRLF)
*
RETURN SELF

METHOD Close() CLASS XRtf
FWrite(SELF:Handle,"}"+CRLF)
FClose(SELF:Handle)
RETURN SELF
METHOD WriteRow(nTable,aRay) CLASS XRtf
LOCAL j
LOCAL a1
LOCAL c1 := ''
LOCAL xx
LOCAL xSize
*
IF nTable == 0  && riga vuota
   IF Empty(aRay)
      FWrite(SELF:Handle,"\pard\plain \ql \txttrn {\f0\fs20  }\par"+CRLF)
   ENDIF
   RETURN SELF
ENDIF
*
IF !Empty(SELF:aTable)
   FOR j := 1 TO Len(aRay)
      IF j == 1
         a1 := StToAr(SELF:aTable[nTable,1],';')
         xx := 1
         c1 += a1[xx++]
      ENDIF
      IF aRay[j]:VertTop
         c1 += " \clvertalt" && allinea in alto il contenuto della cella
         ELSEIF aRay[j]:VertCenter
         c1 += " \clvertalc" && centra vert. il contenuto della cella
      ELSE
         c1 += " \clvertalb" && allinea in basso il contenuto della cella
      ENDIF
      ** Creazione dei Bordi
      IF !Empty(aRay[j]:Border)
         xSize := aRay[j]:Size
         IF "Q" $ aRay[j]:Border
            xSize := NTrim(Val(xSize)*2)
         ENDIF
         IF "T" $ aRay[j]:Border
            c1 += " \clbrdrt\brdrs\brdrw"+xSize
         ENDIF
         IF "L" $ aRay[j]:Border
            c1 += " \clbrdrl\brdrs\brdrw"+xSize
         ENDIF
         IF "R" $ aRay[j]:Border
            c1 += " \clbrdrr\brdrs\brdrw"+xSize
         ENDIF
         IF "B" $ aRay[j]:Border
            c1 += " \clbrdrb\brdrs\brdrw"+xSize
         ENDIF
      ENDIF
      c1 += " "+a1[xx++]
   NEXT
ENDIF
FWrite(SELF:Handle,c1+CRLF)
*
FOR j := 1 TO Len(aRay)
   IF  ValType(aRay[j]:Label) == 'B'
      SELF:WriteBmp(Eval(aRay[j]:Label))
   ELSE
      FWrite(SELF:Handle,"\pard\plain\intbl \sa10\sl"+SELF:HRow)
      FWrite(SELF:Handle,"\q"+aRay[j]:Alignment+"\txttrn {")
      IF !Empty(aRay[j]:Color)
         FWrite(SELF:Handle,"\cf"+aRay[j]:Color)
      ENDIF
      IF aRay[j]:Bold
         FWrite(SELF:Handle,"\b")
      ENDIF
      IF aRay[j]:Underline
         FWrite(SELF:Handle,"\ul")
      ENDIF
      IF aRay[j]:Italic
         FWrite(SELF:Handle,"\i")
      ENDIF
      IF Empty(aRay[j]:Label)
         FWrite(SELF:Handle,"\f0\fs10\sl10 }")
      ELSE
         FWrite(SELF:Handle,"\f"+aRay[j]:font+"\fs"+aRay[j]:Size+"\sl"+SELF:HRow)
         IF  "|" $ aRay[j]:Label
            FWrite(SELF:Handle," "+StrTran(aRay[j]:Label,'|','\par ')+"}")
         ELSE
            FWrite(SELF:Handle," "+aRay[j]:Label+"}")
         ENDIF
      ENDIF
      IF aRay[j]:Page
         FWrite(SELF:Handle,"{\f"+aRay[j]:font+"\fs"+aRay[j]:Size+' '+NTrim(SELF:Page)+"}")
      ENDIF
      IF aRay[j]:Day
         FWrite(SELF:Handle,"{\f"+aRay[j]:font+"\fs"+aRay[j]:Size+' '+DToC(date())+"}")
      ENDIF
   ENDIF
   FWrite(SELF:Handle,"\cell"+CRLF)
NEXT
FWrite(SELF:Handle,"\row"+CRLF)
SELF:CurRow:=SELF:CurRow+1
*
RETURN SELF

METHOD NewSection() CLASS XRtf
FWrite(SELF:Handle,"\pard\plain \ql {\f0\fs20 \sect}\sectd"+CRLF)
SELF:Page:=SELF:Page+1
SELF:CurRow := 0
*
RETURN SELF
METHOD WriteFree(obj) CLASS XRtf
*
FWrite(SELF:Handle,"\pard\plain ")
FWrite(SELF:Handle,"\q"+obj:Alignment+"\txttrn {")
IF !Empty(obj:Color)
   FWrite(SELF:Handle,"\cf"+obj:Color)
ENDIF
IF obj:Bold
   FWrite(SELF:Handle,"\b")
ENDIF
IF obj:Underline
   FWrite(SELF:Handle,"\ul")
ENDIF
IF obj:Italic
   FWrite(SELF:Handle,"\i")
ENDIF
FWrite(SELF:Handle,"\f"+obj:font+"\fs"+obj:Size)
IF  "|" $ obj:Label
   FWrite(SELF:Handle," "+StrTran(obj:Label,'|','\par ')+"}")
ELSE
   FWrite(SELF:Handle," "+obj:Label+"}")
ENDIF
FWrite(SELF:Handle,"\par"+CRLF)
*
RETURN SELF

METHOD WriteBmp(xFile) CLASS XRtf
LOCAL y
LOCAL z
LOCAL x
*
x := FOpen(xFile,0)
y := FSeek(x,0,2)
FSeek(x,0)
DO WHILE .T.
   z := FReadStr(x,1024)
   FWrite(SELF:Handle,z)
   IF Len(z) < 100
      EXIT
   ENDIF
ENDDO
FWrite(SELF:Handle,CRLF)
FClose(x)
*
RETURN SELF
METHOD PageHeader(x) CLASS XRtf
FWrite(SELF:Handle,"{\header\ql "+x+"}"+CRLF)
RETURN SELF
METHOD PageFooter(x) CLASS XRtf
FWrite(SELF:Handle,"{\footer\ql "+x+"}"+CRLF)
RETURN SELF
METHOD NewPage() CLASS XRtf
FWrite(SELF:Handle,"\pard\plain \ql \txttrn {\f0\fs18 \par\page}"+CRLF)
SELF:Page:=SELF:Page+1
SELF:CurRow := 0
RETURN SELF

METHOD EmptyRow() CLASS XRtf
RETURN SELF:WriteRow(0,{})

STATIC FUNCTION MakeList(aTbl)
LOCAL i
LOCAL n
LOCAL h
LOCAL aRay
LOCAL Stringa
*
aRay    :=      {}
h := 72
*
FOR n := 1 TO Len(aTbl)
   stringa := "\trowd\trgaph"+NTrim(h)+"\trleft-"+NTrim(h)
   FOR i := 1 TO Len(aTbl[n])
      stringa += ";\cellx"+NTrim(aTbl[n,i])
   NEXT
   AAdd(aRay,Stringa)
NEXT
*
RETURN aRay
METHOD BookMark(cBook,cText) CLASS XRtf
FWrite(SELF:Handle,"{\*\bkmkstart "+cBook+"} "+cText+"{\*\bkmkend "+cBook+"}")
RETURN SELF

METHOD HiddenText(x) CLASS XRtf
FWrite(SELF:Handle,"{\v "+x+"}")
RETURN SELF
STATIC FUNCTION MakeTable(aTemp,aCoord)
LOCAL aRay
LOCAL aTbl
LOCAL i
LOCAL x
LOCAL y
LOCAL k
LOCAL j
*
j := Val(aCoord[1])-(Val(aCoord[4])+Val(aCoord[3]))
*
aRay   := {}
aTbl   := {}
y := j/100
k := 0
FOR i := 1 TO Len(aTemp)
   x := y*aTemp[i]
   k += x
   IF i == Len(aTemp) .and. k < j
      k := j
   ENDIF
   AAdd(aRay,Int(k))
NEXT
AAdd(aTbl,aRay)
*
RETURN aTbl
*
PROCEDURE RTF_BookMark(cBook,cText)
oRtf:BookMark(cBook,cText)
RETURN

PROCEDURE RTF_CLOSE()
oRtf:Close()
RETURN
PROCEDURE RTF_EMPTYROW()
oRtf:EmptyRow()
RETURN
PROCEDURE RTF_HiddenText(x)
oRtf:HiddenText(x)
RETURN
PROCEDURE RTF_NEWSECTION()
oRtf:NewSection()
RETURN
PROCEDURE RTF_OPEN(cFile,aTable,cOrient,cFont,cSize,aCoord)
*
Default(@cOrient,'P')
Default(@cFont  ,'0')
Default(@cSize  ,'20')
*
oRtf := XRTF():New(cFile,aTable,cOrient,cFont,cSize,aCoord)
*
RETURN
PROCEDURE RTF_PageFooter(x)
oRtf:PageFooter(x)
RETURN
PROCEDURE RTF_PageHeader(x)
oRtf:PageHeader(x)
RETURN
PROCEDURE RTF_SetOrientation(cOrient)
oRtf:SetOrientation(cOrient)
RETURN
PROCEDURE RTF_WriteFree(obj)
oRtf:WriteFree(obj)
RETURN
PROCEDURE RTF_WRITEROW(nTab,aRay)
oRtf:WriteRow(nTab,aRay)
RETURN
FUNCTION RTF_CURROW()
RETURN oRtf:CurRow
FUNCTION RTF_WriteBmp(xFile)
oRtf:WriteBmp(xFile)
Return

